Imports System.Data.SqlClient
Imports System.Data
Imports System.Configuration

'========================================================================================
'HLDirDBData - Manages Database Access for Online directory Application 
'========================================================================================
Public Class HLDirDBData

  '========================================================================================
  'Function GetSearchLists - Returns all lists required for search page
  '========================================================================================
  Public Function GetSearchLists() As DataSet

    Dim cn As New SqlConnection(ConfigurationSettings.AppSettings("ConnectionString"))
    Dim cmd As New SqlDataAdapter("GetSearchLists", cn)
    Dim ds As New DataSet
    Dim sql As String

    cmd.SelectCommand.CommandType = CommandType.StoredProcedure

    cmd.Fill(ds)

    ds.Tables(0).TableName = "ProgramCategories"
    ds.Tables(1).TableName = "Programs"
    ds.Tables(2).TableName = "BuildingTypes"
    ds.Tables(3).TableName = "GroupsServed"
    ds.Tables(4).TableName = "TargetGroups"
    ds.Tables(5).TableName = "ProgramsCombined"

    'Add Cities
    '02/17/05: Changed to handle new db where multiple cities associated with a residence
    'sql = "select distinct Residence.ListCitiesID, " + HousingDB() + "tblListCities.cityName "
    'sql += "from Residence LEFT OUTER JOIN " + HousingDB() + "tblListCities ON Residence.ListCitiesID=" + HousingDB() + "tblListcities.ListCitiesID "
    'sql += "WHERE Residence.ListCitiesID Is Not NULL ORDER BY " + HousingDB() + "tblListCities.cityName"

    sql = "select distinct " + HousingDB() + "tblListCities.ListCitiesID, " + HousingDB() + "tblListCities.cityName "
    sql += "from " + HousingDB() + "tblListCities RIGHT OUTER JOIN " + HousingDB() + "tblPropertyCity ON "
    sql += HousingDB() + "tblListCities.ListCitiesID=" + HousingDB() + "tblPropertyCity.ListCitiesID "
    sql += "LEFT OUTER JOIN " + HousingDB() + "tblListCounties ON " + HousingDB() + "tblListCities.ListCountiesID=" + HousingDB() + "tblListCounties.ListCountiesID "
    sql += "WHERE ListResourcesID=1 "

    If GetRegion() <> 0 Then
      sql += " AND " + HousingDB() + "tblListCounties.ListRegionsID=" + GetRegion.ToString + " "
    End If

    sql += " ORDER BY " + HousingDB() + "tblListCities.cityName"

    cmd = New SqlDataAdapter(sql, cn)
    cmd.SelectCommand.CommandType = CommandType.Text
    cmd.Fill(ds, "Cities")

    'Add Counties
    'sql = "select distinct Residence.ListcountiesID, " + HousingDB() + "tblListcounties.CountyName "
    'sql += "from Residence LEFT OUTER JOIN " + HousingDB() + "tblListcounties ON Residence.ListcountiesID=" + HousingDB() + "tblListcounties.ListcountiesID "
    'sql += "WHERE Residence.ListcountiesID Is Not NULL ORDER BY " + HousingDB() + "tblListcounties.CountyName"

    sql = "select distinct " + HousingDB() + " tblListCounties.ListCountiesID, " + HousingDB() + "tblListcounties.CountyName "
    sql += "from " + HousingDB() + "tblListCounties RIGHT OUTER JOIN " + HousingDB() + "tblPropertyCounty ON "
    sql += HousingDB() + "tblListCounties.ListCountiesID=" + HousingDB() + "tblPropertyCounty.ListcountiesID "
    sql += "WHERE ListResourcesID=1 "

    If GetRegion() <> 0 Then
      sql += " AND " + HousingDB() + "tblListCounties.ListRegionsID=" + GetRegion.ToString + " "
    End If

    sql += " ORDER BY " + HousingDB() + "tblListcounties.CountyName"

    cmd = New SqlDataAdapter(sql, cn)
    cmd.SelectCommand.CommandType = CommandType.Text
    cmd.Fill(ds, "Counties")

    Return ds

  End Function

  '========================================================================================
  'Function GetResidence - Retrieve Residence record
  '========================================================================================
  Public Function GetResidence(ByVal aintResidenceID As Integer) As DataRow

    Dim cn As New SqlConnection(ConfigurationSettings.AppSettings("ConnectionString"))
    Dim cmd As New SqlCommand
    Dim ds As DataSet
    Dim strSQL As String

    strSQL = "SELECT vwResidenceData.*, CityName=ISNULL(CityName,''), CountyName=ISNULL(CountyName,''), "
    strSQL += "StateAbbr=ISNULL(StateAbbr,'') FROM vwResidenceData "
    strSQL += "LEFT OUTER JOIN " + HousingDB() + "tblListCities ON vwResidenceData.ListCitiesID=" + HousingDB() + "tblListCities.ListCitiesID "
    strSQL += "LEFT OUTER JOIN " + HousingDB() + "tblListCounties ON vwResidenceData.ListCountiesID=" + HousingDB() + "tblListCounties.ListCountiesID "
    strSQL += "LEFT OUTER JOIN " + HousingDB() + "tblListStates ON vwResidenceData.ListStatesID=" + HousingDB() + "tblListStates.ListStatesID "
    strSQL += "WHERE vwResidenceData.Residence_ResID=" + aintResidenceID.ToString
    cmd.CommandText = strSQL
    cmd.CommandType = CommandType.Text
    cmd.Connection = cn

    Dim param As SqlParameter

    param = cmd.Parameters.Add("@ResidenceID", SqlDbType.Int)
    param.Value = aintResidenceID

    Dim da As SqlDataAdapter = New SqlDataAdapter(cmd)

    ds = New DataSet

    da.Fill(ds)

    Return ds.Tables(0).Rows(0)

  End Function
#Region " Unused Code "

  '========================================================================================
  'Function GetResults - Returns search results
  '========================================================================================
  'Public Function GetResults(ByVal astrCityList As String, ByVal astrProgramList As String, ByVal astrResidenceName As String, _
  'ByVal astrCountyList As String, ByVal astrResidenceTypesList As String, ByVal astrGroupsServedList As String, _
  'ByVal astrTargetSupportiveServices As String, ByVal astrBedroomsList As String, ByVal aintAccessibilityNeeds As Integer, ByVal aintDisplayType As Integer, _
  'ByVal aintSortOrder As Integer, ByVal astrSortDirection As String) As DataSet

  '  Dim cn As New SqlConnection(ConfigurationSettings.AppSettings("ConnectionString"))
  '  Dim cmd As New SqlCommand
  '  Dim ds As DataSet
  '  cmd.CommandText = "GetResults"
  '  cmd.CommandType = CommandType.StoredProcedure
  '  cmd.Connection = cn

  '  Dim param As SqlParameter

  '  param = cmd.Parameters.Add("@CityList_Search", SqlDbType.VarChar, 4000)
  '  param.Value = astrCityList

  '  'param = cmd.Parameters.Add("@ProgramList_Search", SqlDbType.VarChar, 4000)
  '  'param.Value = astrProgramList

  '  param = cmd.Parameters.Add("@ResidenceName_Search", SqlDbType.VarChar, 100)
  '  param.Value = astrResidenceName

  '  param = cmd.Parameters.Add("@CountyList_Search", SqlDbType.VarChar, 4000)
  '  param.Value = astrCountyList

  '  'Set group served parameters
  '  If InStr(astrResidenceName, "TypeEld") > 0 Then
  '    param = cmd.Parameters.Add("@GroupServedEld", SqlDbType.Bit)
  '    param.Value = 1
  '  End If
  '  If InStr(astrResidenceName, "TypeDis") > 0 Then
  '    param = cmd.Parameters.Add("@GroupServedDis", SqlDbType.Bit)
  '    param.Value = 1
  '  End If
  '  If InStr(astrResidenceName, "TypeFam") > 0 Then
  '    param = cmd.Parameters.Add("@GroupServedFam", SqlDbType.Bit)
  '    param.Value = 1
  '  End If
  '  If InStr(astrResidenceName, "TypeSAdult") > 0 Then
  '    param = cmd.Parameters.Add("@GroupServedSAdult", SqlDbType.Bit)
  '    param.Value = 1
  '  End If
  '  If InStr(astrResidenceName, "TypeUnacYouth") > 0 Then
  '    param = cmd.Parameters.Add("@GroupServedDis", SqlDbType.Bit)
  '    param.Value = 1
  '  End If

  '  Dim Programs() As String
  '  Dim ProgramParameter As String = ""
  '  Dim i As Integer
  '  If astrProgramList <> Nothing Then
  '    Programs = Split(astrProgramList)
  '    For i = 0 To UBound(Programs)
  '      ProgramParameter += Programs(i) + "=1,"
  '    Next
  '  End If
  '  If ProgramParameter.Length > 0 Then
  '    ProgramParameter = Mid(ProgramParameter, 1, ProgramParameter.Length - 1)
  '  End If
  '  param = cmd.Parameters.Add("@ProgramList_Search", SqlDbType.VarChar, 4000)
  '  param.Value = ProgramParameter

  '  Dim SupportiveServices() As String
  '  Dim SupportiveServicesParameter As String = ""
  '  If astrTargetSupportiveServices <> Nothing Then
  '    SupportiveServices = Split(astrTargetSupportiveServices)
  '    For i = 0 To UBound(SupportiveServices)
  '      SupportiveServicesParameter += SupportiveServices(i) + "=1,"
  '    Next
  '  End If
  '  If SupportiveServicesParameter.Length > 0 Then
  '    SupportiveServicesParameter = Mid(SupportiveServicesParameter, 1, SupportiveServicesParameter.Length - 1)
  '  End If
  '  param = cmd.Parameters.Add("@SupportiveServicesList_Search", SqlDbType.VarChar, 4000)
  '  param.Value = SupportiveServicesParameter


  '  Dim Residences() As String
  '  If astrResidenceTypesList <> Nothing Then
  '    Residences = Split(astrResidenceTypesList)
  '    For i = 0 To UBound(Residences)
  '      param = cmd.Parameters.Add("@" & Residences(i), SqlDbType.Bit)
  '      param.Value = 1
  '    Next
  '  End If

  '  Dim Bedrooms() As String
  '  If astrBedroomsList <> Nothing Then
  '    Bedrooms = Split(astrBedroomsList)
  '    For i = 0 To UBound(Bedrooms)
  '      param = cmd.Parameters.Add("@" & Bedrooms(i), SqlDbType.Bit)
  '      param.Value = 1
  '    Next
  '  End If

  '  param = cmd.Parameters.Add("@Accessibility", SqlDbType.Int)
  '  param.Value = aintAccessibilityNeeds

  '  param = cmd.Parameters.Add("@DisplayType", SqlDbType.TinyInt)
  '  param.Value = aintDisplayType

  '  param = cmd.Parameters.Add("@SortBy", SqlDbType.TinyInt)
  '  param.Value = aintSortOrder

  '  Dim da As SqlDataAdapter = New SqlDataAdapter(cmd)

  '  ds = New DataSet

  '  da.Fill(ds)

  '  Return ds


  'End Function

#End Region

  Private Function HousingDB() As String

    Return ConfigurationSettings.AppSettings("HousingDB") & ".dbo."

  End Function
  '========================================================================================
  'Function GetVacancyResultsDynamicSQL - Returns search results
  '========================================================================================
  Public Function GetVacancyResultsDynamicSQL(ByVal ablnOpenWaitingLists As Boolean, ByVal ablnAvailableVacancies As Boolean, _
  ByVal astrCityList As String, ByVal astrProgramList As String, ByVal astrResidenceName As String, _
  ByVal astrCountyList As String, ByVal astrResidenceTypesList As String, ByVal astrGroupsServedList As String, _
  ByVal astrTargetSupportiveServices As String, ByVal astrBedroomsList As String, ByVal aintAccessibilityNeeds As Integer, ByVal aDisplayType As DisplayTypes, _
  ByVal aSortOrder As SearchSortOrder, ByVal astrSortDirection As String) As DataSet

    Dim cn As New SqlConnection(ConfigurationSettings.AppSettings("ConnectionString"))
    Dim cmd As New SqlCommand
    Dim ds As DataSet
    Dim strSQLWhere As String
    Dim strTempWhere As String = ""
    Dim strVacancyWhere As String = " AND NOT (Residence_ResID IS NULL) "
    Dim strSQLOrder As String
    Dim strSQL As String
    Dim VacDB As String = ConfigurationSettings.AppSettings("VacancyDB") & ".dbo."
    Dim i As Integer
    Dim JoinType As String
    'Dim FixResidenceName As String = Replace(astrResidenceName, "'", "''")

    Try

      '------------------------------------------------------------------------------
    ' Build SQL for first table (which contains the results to be shown in the grid
    '------------------------------------------------------------------------------
    If aDisplayType = DisplayTypes.AllProperties Then
      JoinType = "RIGHT "
    Else
      JoinType = "LEFT "
    End If

    'strSQL = "SELECT " + VacDB + "vwDirectoryVacancies.*, vwPropertySearchResults.*, CityName=ISNULL(CityName,''), CountyName=ISNULL(CountyName,''), "
      strSQL = "SELECT Distinct AccessibilityInd=ISNULL(AccessibilityInd, 0), OppTypeID=ISNULL(OppTypeID, ''), NumberBedrooms=ISNULL(NumberBedrooms, ''), "
      strSQL += "RentDescription=ISNULL(RentDescription, ''), SubsidyVoucherInd=ISNULL(SubsidyVoucherInd, 0), ReferralRequiredInd=ISNULL(ReferralRequiredInd, 0), "
      strSQL += "CombinedNotes=ISNULL(" + VacDB + "vwDirectoryVacancies.CombinedNotes, ''), "
      strSQL += VacDB + "vwDirectoryVacancies.*, vwPropertySearchResults.*, CityName='', CountyName='', "
      strSQL += "StateAbbr=ISNULL(StateAbbr,'') FROM " + VacDB + "vwDirectoryVacancies "
      strSQL += JoinType + "OUTER JOIN vwPropertySearchResults ON " + VacDB + "vwDirectoryVacancies.ResourceUniqueID=vwPropertySearchResults.Residence_ResID "
      strSQL += "LEFT OUTER JOIN " + HousingDB() + "vwDirectoryCities ON vwPropertySearchResults.Residence_ResID=" + HousingDB() + "vwDirectoryCities.ResourceUniqueID "
      strSQL += "LEFT OUTER JOIN " + HousingDB() + "vwDirectoryCounties ON vwPropertySearchResults.Residence_ResID=" + HousingDB() + "vwDirectoryCounties.ResourceUniqueID "
      strSQL += "LEFT OUTER JOIN " + HousingDB() + "tblListStates ON vwPropertySearchResults.ListStatesID=" + HousingDB() + "tblListStates.ListStatesID "

    '------------------------------------------------------------------------------
    ' Build WHERE Clause
    '------------------------------------------------------------------------------

      'Handle regions filter
      If GetRegion() <> 0 Then
        strSQLWhere += " AND " + HousingDB() + "vwDirectoryCounties.ListRegionsID=" + GetRegion.ToString + " "
      End If

      'Residence Name SQL
      strSQLWhere += GetSQLForResidenceName(astrResidenceName)

      'City Selection Filter
      If astrCityList <> Nothing Then
        strSQLWhere += " AND (" + HousingDB() + "vwDirectoryCities.ListCitiesID IN (" + astrCityList + ")) "
      End If

      'County Selection Filter
      If astrCountyList <> Nothing Then
        strSQLWhere += " AND (" + HousingDB() + "vwDirectoryCounties.ListCountiesID IN (" + astrCountyList + ")) "
      End If

      'Residence Types Selection Filter
      strSQLWhere += GetSQLFromList(astrResidenceTypesList, "=1")

      'Housing Program Selection Filter
      strSQLWhere += GetSQLForPrograms(astrProgramList)

      'Groups Served Selection Filter
      strSQLWhere += GetSQLFromList(astrGroupsServedList, "=1")

      'Target Group for Supportive Services Selection Filter
      strSQLWhere += GetSQLFromList(astrTargetSupportiveServices, "=1")

      'Bedrooms Selection Filter
      Dim Bedrooms() As String
      Dim BedroomList As String
      If astrBedroomsList <> Nothing Then
        Bedrooms = Split(astrBedroomsList, ",")
        For i = 0 To UBound(Bedrooms)
          strTempWhere += " OR (" + Bedrooms(i) + ">0) "
        Next
        If Mid(strTempWhere, 1, 3) = " OR" Then
          strSQLWhere += " AND " + "(" + Mid(strTempWhere, 4, strTempWhere.Length) + ") "
        End If
        strTempWhere = ""
        ''If searching on vacancies, then also check the bedroom values for opportunities for matches
        'If ablnAvailableVacancies Or ablnOpenWaitingLists Then
        '  strSQLWhere += " AND (NumberBedrooms='M' OR NumberBedrooms IN ("
        '  For i = 0 To UBound(Bedrooms)
        '    BedroomList += "'" + Replace(Bedrooms(i), "Br", "") + "',"
        '  Next
        '  BedroomList = Mid(BedroomList, 1, Len(BedroomList) - 1)
        '  strSQLWhere += BedroomList + ")) "
        'End If
      End If

      'Accessibility Needs Selection Filter
      Select Case aintAccessibilityNeeds
        Case -1
          'Do nothing
        Case 0
          strSQLWhere += " AND (Accessible=" + aintAccessibilityNeeds.ToString + ") "
        Case 1
          strSQLWhere += " AND (Accessible=" + aintAccessibilityNeeds.ToString + ") "
      End Select

      ''If limited to vacancies then include vacancies count
      'If aDisplayType <> DisplayTypes.AllProperties Then

      Select Case aDisplayType
        Case DisplayTypes.Both
          strVacancyWhere += " AND (SELECT COUNT(*) FROM " & VacDB & "vwdirectoryvacancies Vac WHERE vwPropertySearchResults.Residence_ResID=vac.ResourceUniqueID "
          strVacancyWhere += " AND (OppTypeID=1 OR OppTypeID=2) "
          'If searching on vacancies, then also check the accessibility setting for the vacancies
          If aintAccessibilityNeeds = 1 Then
            strVacancyWhere += " AND (Vac.AccessibilityInd=1) "
          End If

          strVacancyWhere += ") > 0"

        Case DisplayTypes.AvailableVacancies
          'strVacancyWhere += " AND (OppTypeID=2) "
          strVacancyWhere += " AND " & VacDB & "vwdirectoryvacancies.OppTypeID=2 "
          'If searching on vacancies, then also check the accessibility setting for the vacancies
          If aintAccessibilityNeeds = 1 Then
            strVacancyWhere += " AND (" & VacDB & "vwdirectoryvacancies.AccessibilityInd=1) "
          End If
        Case DisplayTypes.OpenWaitingLists
          'strVacancyWhere += " AND (OppTypeID=1) "
          strVacancyWhere += " AND " & VacDB & "vwdirectoryvacancies.OppTypeID=1 "
          'If searching on vacancies, then also check the accessibility setting for the vacancies
          If aintAccessibilityNeeds = 1 Then
            strVacancyWhere += " AND (" & VacDB & "vwdirectoryvacancies.AccessibilityInd=1) "
          End If
      End Select

      'If bedrooms included in search, then add to vacancy criteria
      If astrBedroomsList <> Nothing Then
        strVacancyWhere += " AND (NumberBedrooms='M' OR NumberBedrooms IN ("
        For i = 0 To UBound(Bedrooms)
          BedroomList += "'" + Replace(Bedrooms(i), "Br", "") + "',"
        Next
        BedroomList = Mid(BedroomList, 1, Len(BedroomList) - 1)
        strVacancyWhere += BedroomList + ")) "
      End If

      'End If

      'Handle Sort by
      Select Case aSortOrder
        Case SearchSortOrder.City
          strSQLOrder += " ORDER BY " + HousingDB() + "tblListCities.CityName " + astrSortDirection + ", ResidenceName ASC "
        Case SearchSortOrder.County
          strSQLOrder += " ORDER BY CountyName " + astrSortDirection + ", ResidenceName ASC "
        Case SearchSortOrder.GroupsServed
          If astrSortDirection = "DESC" Then
            strSQLOrder += " ORDER BY TypeFam DESC, ResidenceName ASC "
          Else
            strSQLOrder += " ORDER BY TypeEld DESC, ResidenceName ASC "
          End If
          'strSQLOrder += " ORDER BY CityName " + astrSortDirection + ", ResidenceName ASC "
        Case SearchSortOrder.OpeningType       'Opening Type
          strSQLOrder += " ORDER BY OppTypeID " + astrSortDirection + ", ResidenceName ASC "
        Case SearchSortOrder.Bedrooms       'Bedrooms
          strSQLOrder += " ORDER BY NumberBedrooms " + astrSortDirection + ", ResidenceName ASC "
        Case SearchSortOrder.Rent       'Rent
          'strSQLOrder += " ORDER BY RentDescription " + astrSortDirection + ", ResidenceName ASC "
          strSQLOrder += " ORDER BY RentLowAmount " + astrSortDirection + ", RentDescription " + astrSortDirection + ", ResidenceName ASC "
        Case SearchSortOrder.Accessibility     'Accessibility
          strSQLOrder += " ORDER BY AccessibilityInd " + astrSortDirection + ", ResidenceName ASC "
        Case SearchSortOrder.VoucherOK      'SubsidyVoucherInd 
          strSQLOrder += " ORDER BY SubsidyVoucherInd " + astrSortDirection + ", ResidenceName ASC "
        Case SearchSortOrder.Referral      'Referral Required
          strSQLOrder += " ORDER BY ReferralRequiredInd " + astrSortDirection + ", ResidenceName ASC "
        Case SearchSortOrder.Notes      'Notes
          strSQLOrder += " ORDER BY CombinedNotes " + astrSortDirection + ", ResidenceName ASC "
        Case Else '(including default...)
          strSQLOrder += " ORDER BY ResidenceName " + astrSortDirection
      End Select

      'TODO Handle Display Type

      strSQLWhere = Mid(strSQLWhere, 5)
      If strSQLWhere <> Nothing Then
        strSQLWhere = " WHERE " + strSQLWhere
      ElseIf strVacancyWhere <> Nothing Then
        strVacancyWhere = " WHERE " + Mid(strVacancyWhere, 5)
      End If
      If aDisplayType <> DisplayTypes.AllProperties Then
        cmd.CommandText = strSQL + strSQLWhere + strVacancyWhere + strSQLOrder
      Else
        cmd.CommandText = strSQL + strSQLWhere + strSQLOrder
      End If
      cmd.CommandType = CommandType.Text
      cmd.Connection = cn

      System.Web.HttpContext.Current.Trace.Write("SearchResults-SQL", cmd.CommandText)

      Dim da As SqlDataAdapter = New SqlDataAdapter(cmd)

      ds = New DataSet

      da.Fill(ds, "SearchResults")

      'Grab some totals
      'If strSQLWhere = Nothing Then
      '  strVacancyWhere = " WHERE " + Mid(strVacancyWhere, 5)
      'End If

      strSQL = "SELECT distinct vwPropertySearchResults.ResidenceName FROM " + VacDB + "vwDirectoryVacancies "
      strSQL += "LEFT OUTER JOIN vwPropertySearchResults ON " + VacDB + "vwDirectoryVacancies.ResourceUniqueID=vwPropertySearchResults.Residence_ResID "
      strSQL += "LEFT OUTER JOIN " + HousingDB() + "vwDirectoryCities ON vwPropertySearchResults.Residence_ResID=" + HousingDB() + "vwDirectoryCities.ResourceUniqueID "
      strSQL += "LEFT OUTER JOIN " + HousingDB() + "vwDirectoryCounties ON vwPropertySearchResults.Residence_ResID=" + HousingDB() + "vwDirectoryCounties.ResourceUniqueID "
      strSQL += "LEFT OUTER JOIN " + HousingDB() + "tblListStates ON vwPropertySearchResults.ListStatesID=" + HousingDB() + "tblListStates.ListStatesID "

      cmd = New SqlCommand
      cmd.CommandText = strSQL + strSQLWhere + strVacancyWhere
      System.Web.HttpContext.Current.Trace.Write("PropertiesWithVacanciesCountSQL", cmd.CommandText)

      cmd.CommandType = CommandType.Text
      cmd.Connection = cn

      da = New SqlDataAdapter(cmd)
      da.Fill(ds, "PropertiesWithVacancies")

      strSQL = "SELECT distinct VacanciesID FROM " + VacDB + "vwDirectoryVacancies "
      'strSQL += "RIGHT OUTER JOIN vwPropertySearchResults ON " + VacDB + "vwDirectoryVacancies.ResourceUniqueID=vwPropertySearchResults.Residence_ResID "
      strSQL += "LEFT OUTER JOIN vwPropertySearchResults ON vwPropertySearchResults.Residence_ResID=" + VacDB + "vwDirectoryVacancies.ResourceUniqueID "
      strSQL += "LEFT OUTER JOIN " + HousingDB() + "vwDirectoryCities ON vwPropertySearchResults.Residence_ResID=" + HousingDB() + "vwDirectoryCities.ResourceUniqueID "
      strSQL += "LEFT OUTER JOIN " + HousingDB() + "vwDirectoryCounties ON vwPropertySearchResults.Residence_ResID=" + HousingDB() + "vwDirectoryCounties.ResourceUniqueID "

      cmd = New SqlCommand
      cmd.CommandText = strSQL + strSQLWhere + strVacancyWhere
      cmd.CommandType = CommandType.Text
      cmd.Connection = cn
      System.Web.HttpContext.Current.Trace.Write("VacanciesCountSQL", cmd.CommandText)

      da = New SqlDataAdapter(cmd)
      da.Fill(ds, "Vacancies")

      Return ds

    Catch exsql As SqlException
      Throw
    Catch ex As Exception
      Throw
    End Try

  End Function

  '========================================================================================
  'Function IsTransitional - Is the property transitional?
  '========================================================================================
  Public Function IsTransitional(ByVal aResidenceID As Integer) As Boolean

    Dim cn As New SqlConnection(ConfigurationSettings.AppSettings("ConnectionString"))
    Dim cmd As New SqlCommand
    Dim strSQL As String

    Try

      strSQL = "SELECT ISNULL(Transitional,0) FROM Programs WHERE ResID=" + aResidenceID.ToString

      cmd.CommandType = CommandType.Text
      cmd.CommandText = strSQL
      cmd.Connection = cn

      cn.Open()

      System.Web.HttpContext.Current.Trace.Write("strsql", strSQL)

      Return CType(cmd.ExecuteScalar, Boolean)

    Catch ex As Exception
      Throw
    Finally
      cmd.Dispose()
    End Try

  End Function

  '========================================================================================
  'Function GetSelectedGroupsServed - Retrieve a list of selected groups served for the property
  '========================================================================================
  Public Function GetSelectedGroupsServed(ByVal aGroupsServedList As String) As String

    Dim cn As New SqlConnection(ConfigurationSettings.AppSettings("ConnectionString"))
    Dim cmd As New SqlCommand
    Dim strSQL As String

    Try

      strSQL = "declare @c varchar(2000);"
      strSQL += "set @c='';"
      strSQL += "select @c = @c + description + '<br>' "
      strSQL += "FROM GroupsServed WHERE Dir_Relationship IN (" + aGroupsServedList + ");"
      strSQL += "select GroupsServied = @c;"


      cmd.CommandType = CommandType.Text
      cmd.CommandText = strSQL
      cmd.Connection = cn

      cn.Open()

      System.Web.HttpContext.Current.Trace.Write("strsql", strSQL)

      Return CType(cmd.ExecuteScalar, String)

    Catch ex As Exception
      Throw
    Finally
      cmd.Dispose()
    End Try

  End Function
  '========================================================================================
  'Function GetVacancyResultsbyProperty - Returns search results
  '========================================================================================
  Public Function GetVacancyResultsbyProperty(ByVal aintResidenceID As Integer) As DataSet

    Dim cn As New SqlConnection(ConfigurationSettings.AppSettings("ConnectionString"))
    Dim cmd As New SqlCommand
    Dim ds As DataSet
    Dim strSQLWhere As String
    Dim strSQL As String
    Dim VacDB As String = ConfigurationSettings.AppSettings("VacancyDB") & ".dbo."
    Dim i As Integer

    strSQL = "SELECT " + VacDB + "vwDirectoryVacancies.*, vwPropertySearchResults.* "
    strSQL += "FROM " + VacDB + "vwDirectoryVacancies "
    strSQL += "LEFT OUTER JOIN vwPropertySearchResults ON " + VacDB + "vwDirectoryVacancies.ResourceUniqueID=vwPropertySearchResults.Residence_ResID "

    strSQLWhere = "Residence_ResID=" + aintResidenceID.ToString
    'TODO Handle Display Type

    If strSQLWhere <> Nothing Then
      strSQLWhere = " WHERE " + strSQLWhere
    End If

    cmd.CommandText = strSQL + strSQLWhere
    cmd.CommandType = CommandType.Text
    cmd.Connection = cn

    System.Web.HttpContext.Current.Trace.Write("strsql", strSQL + strSQLWhere)

    Dim da As SqlDataAdapter = New SqlDataAdapter(cmd)

    ds = New DataSet

    da.Fill(ds)

    Return ds


  End Function


  Public Function GetSelectedProgramList(ByVal astrProgramList As String) As DataTable

    Dim cn As New SqlConnection(ConfigurationSettings.AppSettings("ConnectionString"))
    Dim cmd As New SqlCommand
    Dim ds As DataSet
    Dim strSQL As String

    cmd.CommandText = "SELECT Abbreviation, Dir_Relationship FROM HousingProgram WHERE Dir_Relationship IN ('" + Replace(astrProgramList, ",", "','") + "')"
    cmd.CommandType = CommandType.Text
    cmd.Connection = cn

    Dim da As SqlDataAdapter = New SqlDataAdapter(cmd)

    ds = New DataSet

    da.Fill(ds, "Programs")

    Return ds.Tables("Programs")

  End Function


  Public Function GetSelectedBuildingTypesList(ByVal astrBuildingTypesList As String) As DataTable

    Dim cn As New SqlConnection(ConfigurationSettings.AppSettings("ConnectionString"))
    Dim cmd As New SqlCommand
    Dim ds As DataSet
    Dim strSQL As String

    cmd.CommandText = "SELECT Description, Dir_Relationship FROM BuildingTypes WHERE Dir_Relationship IN ('" + Replace(astrBuildingTypesList, ",", "','") + "')"
    cmd.CommandType = CommandType.Text
    cmd.Connection = cn

    Dim da As SqlDataAdapter = New SqlDataAdapter(cmd)

    ds = New DataSet

    da.Fill(ds, "BuildingTypes")

    Return ds.Tables("BuildingTypes")

  End Function


  'Dim sql As String
  'Dim x As Integer
  'Dim arrBedrooms() As String
  'Dim arrCities() As String
  'Dim arrCounties() As String
  'Dim arrResTypes() As String
  'Dim arrProgTypes() As String
  'Dim arrHousingTypes() As String
  'Dim cities, counties As String


  'sql = "SELECT DISTINCT a.Residence_ResID FROM vwResidence a " & _
  ' "INNER JOIN vwHousingType b " & _
  ' "	ON a.Residence_ResID = b.Residence_ResID " & _
  ' "INNER JOIN dbo.vwNumberOfBedrooms c " & _
  ' "	ON a.Residence_ResID = c.ResID " & _
  ' "INNER JOIN dbo.vwPrograms d " & _
  ' "	ON a.Residence_ResID = d.ResID " & _
  ' "INNER JOIN dbo.vwResidenceType e " & _
  ' "	ON a.Residence_ResID = e.Residence_ResID "

  'If Session("ResidenceName") <> "" Then
  '  sql = sql & "WHERE a.Residence_ResName LIKE '%" & Session("ResidenceName") & "%' "
  'Else
  '  If (astrBedroomsList <> "") Or (aintAccessibilityNeeds <> "") Or (astrCityList <> "") Or (astrCountyList <> "") Or (astrCountyList <> "") Or (astrProgramList <> "") Or (astrHousingTypesList <> "") Then
  '    sql = sql & "WHERE a.Residence_ResName LIKE '%" & Trim(astrResidenceName) & "%' "
  '  End If

  '  If (Trim(astrBedroomsList) <> "") And (Left(astrBedroomsList, 4) <> "~all") Then
  '    If InStr(Trim(astrBedroomsList), ",") <> 0 Then
  '      arrBedrooms = Split(astrBedroomsList, ",")
  '      sql = sql & "	AND (c.BR" & Trim(arrBedrooms(x)) & " <> 0 "
  '      For x = 1 To UBound(arrBedrooms)
  '        sql = sql & "	OR c.BR" & Trim(arrBedrooms(x)) & " <> 0 "
  '      Next
  '      sql = sql & "	) "
  '    Else
  '      sql = sql & " AND (c.BR" & Trim(astrBedroomsList) & " <> 0)"
  '    End If
  '  End If
  '  If aintAccessibilityNeeds = "1" Then
  '    sql = sql & "	AND d.Accessible = 1 "
  '  ElseIf aintAccessibilityNeeds = "0" Then
  '    sql = sql & " AND d.Accessible = 0 "
  '  Else
  '    sql = sql & " AND d.Accessible in (0, 1) "
  '  End If
  '  If (astrCityList <> "") And (Left(astrCityList, 4) <> "~all") Then
  '    If InStr(astrCityList, ",") = 0 Then
  '      cities = "'" & astrCityList & "'"
  '    Else
  '      arrCities = Split(astrCityList, ",")
  '      cities = "'" & Trim(arrCities(0)) & "'"
  '      For x = 1 To UBound(arrCities)
  '        cities = cities & ", '" & Trim(arrCities(x)) & "'"
  '      Next
  '    End If
  '  End If
  '  If (astrCountyList <> "") And (Left(astrCountyList, 4) <> "~all") Then
  '    If InStr(astrCountyList, ",") = 0 Then
  '      counties = "'" & astrCountyList & "'"
  '    Else
  '      arrCounties = Split(astrCountyList, ",")
  '      counties = "'" & Trim(arrCounties(0)) & "'"
  '      For x = 1 To UBound(arrCounties)
  '        counties = counties & ", '" & Trim(arrCounties(x)) & "'"
  '      Next
  '    End If
  '  End If
  '  If (Trim(counties) <> "") And (Trim(cities) <> "") Then
  '    sql = sql & "	AND (a.ResCounty in (" & counties & ") AND a.ResCity in (" & cities & ")) "
  '  Else
  '    If Trim(counties) <> "" Then
  '      sql = sql & "	AND a.ResCounty in (" & counties & ") "
  '    End If
  '    If Trim(cities) <> "" Then
  '      sql = sql & "	AND a.ResCity in (" & cities & ") "
  '    End If
  '  End If

  '  If (Trim(astrHousingTypesList) <> "") And (Left(astrHousingTypesList, 4) <> "~all") Then
  '    If InStr(Trim(astrHousingTypesList), ",") = 0 Then
  '      sql = sql & "	AND e." & Trim(astrHousingTypesList) & " = 1 "
  '    Else
  '      arrResTypes = Split(astrHousingTypesList, ",")
  '      sql = sql & "	AND ( e." & Trim(arrResTypes(0)) & " = 1 "

  '      For x = 1 To UBound(arrResTypes)
  '        sql = sql & "	OR e." & Trim(arrResTypes(x)) & " = 1 "
  '      Next
  '      sql = sql & "	) "
  '    End If
  '  End If

  '  HasTransitional = "none"
  '  If (Trim(astrProgramList) <> "") And (Left(astrProgramList, 4) <> "~all") Then
  '    If InStr(Trim(astrProgramList), ",") = 0 Then
  '      sql = sql & "	AND d." & Trim(astrProgramList) & " = 1 "

  '      If LCase(Trim(astrProgramList)) = "transitional" Then
  '        HasTransitional = "single"
  '      Else
  '        HasTransitional = "none"
  '      End If
  '    Else
  '      arrProgTypes = Split(astrProgramList, ",")
  '      sql = sql & "	AND ( d." & Trim(arrProgTypes(0)) & " = 1 "

  '      For x = 1 To UBound(arrProgTypes)
  '        sql = sql & "	OR d." & Trim(arrProgTypes(x)) & " = 1 "
  '      Next
  '      sql = sql & "	) "
  '    End If
  '  End If

  '  If (Trim(astrHousingTypesList) <> "") And (Left(astrHousingTypesList, 4) <> "~all") Then
  '    If InStr(Trim(astrHousingTypesList), ",") = 0 Then
  '      If LCase(Trim(astrHousingTypesList)) = "typesadult" Then
  '        If HasTransitional = "single" Then
  '          sql = sql & "	AND b.TypeSAdult = 1 "
  '        Else
  '          sql = sql & "	AND (b.TypeSAdult = 1 OR b.TypeFam = 1) "
  '        End If
  '      Else
  '        sql = sql & "	AND b." & Trim(astrHousingTypesList) & " = 1 "
  '      End If
  '    Else
  '      arrHousingTypes = Split(astrHousingTypesList, ",")
  '      sql = sql & "	AND ( b." & Trim(arrHousingTypes(0)) & " = 1 "

  '      For x = 1 To UBound(arrHousingTypes)
  '        sql = sql & "	OR b." & Trim(arrHousingTypes(x)) & " = 1 "
  '      Next
  '      sql = sql & "	) "
  '    End If
  '  End If
  '  'end if

  '  'response.write "<b>SQL Call 1: </b>" & sql & "<br><br><br>"

  '  oRsGetNumbers = Server.CreateObject("ADODB.RecordSet")
  '  oRsGetNumbers.Open(sql, oConn, 2, 3)

  '  If Not oRsGetNumbers.eof Then
  '    sql = "SELECT a.*, b.*, c.*, d.*, e.* FROM vwResidence a " & _
  '     "INNER JOIN dbo.vwNumberOfBedrooms b " & _
  '     "	ON a.Residence_ResID = b.Resid " & _
  '     "INNER JOIN dbo.vwPrograms c " & _
  '     "	ON a.Residence_ResID = c.Resid " & _
  '     "INNER JOIN dbo.vwResidenceType d " & _
  '     "	ON a.Residence_ResID = d.Residence_ResID " & _
  '     "INNER JOIN dbo.vwHousingType e " & _
  '     "	ON a.Residence_ResID = e.Residence_ResID " & _
  '     "WHERE a.Residence_ResID IN (" & oRsGetNumbers("Residence_ResID")
  '    oRsGetNumbers.MoveNext()
  '    Do While Not oRsGetNumbers.eof
  '      If Trim(oRsGetNumbers("Residence_ResID")) <> "" Then
  '        sql = sql & ", " & oRsGetNumbers("Residence_ResID")
  '      End If
  '      oRsGetNumbers.MoveNext()
  '    Loop
  '    sql = sql & ") "
  '    If (aintSortOrder = 2) Then
  '      sql = sql & "ORDER BY a.ResCity "
  '      If aintSortDirection = 2 Then
  '        sql = sql & "DESC "
  '      Else
  '        sql = sql & "ASC "
  '      End If
  '      sql = sql & ", a.Residence_ResName ASC"
  '    ElseIf (aintSortOrder = 3) Then
  '      sql = sql & "ORDER BY a.ResCounty "
  '      If aintSortDirection = 2 Then
  '        sql = sql & "DESC"
  '      Else
  '        sql = sql & "ASC"
  '      End If
  '      sql = sql & ", a.Residence_ResName ASC "
  '    ElseIf (aintSortOrder = 4) Then
  '      If aintSortDirection = 2 Then
  '        sql = sql & " ORDER BY b.br6 DESC, b.br5 DESC, b.br4 DESC, b.br3 DESC, b.br2 DESC, b.br1 DESC, b.br0 DESC, a.Residence_ResName ASC "
  '      Else
  '        sql = sql & " ORDER BY b.br0 DESC, b.br1 DESC, b.br2 DESC, b.br3 DESC, b.br4 DESC, b.br5 DESC, b.br6 DESC, a.Residence_ResName ASC "
  '      End If
  '    ElseIf (aintSortOrder = 5) Then
  '      If aintSortDirection = 2 Then
  '        sql = sql & " ORDER BY e.TypeFam DESC, a.Residence_ResName ASC "
  '      Else
  '        sql = sql & " ORDER BY e.TypeEld DESC, a.Residence_ResName ASC "
  '      End If
  '    Else
  '      sql = sql & " ORDER BY a.Residence_ResName "
  '      If aintSortDirection = 2 Then
  '        sql = sql & "DESC"
  '      Else
  '        sql = sql & "ASC"
  '      End If
  '    End If
  '  End If


  'cmd.CommandText = sql
  'cmd.CommandType = CommandType.Text

  Public Function GetCityList(ByVal aResidenceID As Integer) As DataSet


    Dim cn As New SqlConnection(ConfigurationSettings.AppSettings("ConnectionString"))
    Dim cmd As New SqlCommand
    Dim ds As DataSet
    Dim strSQL As String

    strSQL = "SELECT CityName FROM " + HousingDB() + "vwdirectorycities WHERE ResourceUniqueID=" + aResidenceID.ToString + " ORDER BY CityName"
    cmd.CommandText = strSQL
    cmd.CommandType = CommandType.Text
    cmd.Connection = cn

    'Dim param As SqlParameter

    'param = cmd.Parameters.Add("@ResidenceID", SqlDbType.Int)
    'param.Value = aintResidenceID

    Dim da As SqlDataAdapter = New SqlDataAdapter(cmd)

    ds = New DataSet

    da.Fill(ds)

    Return ds

  End Function

  Public Function GetCountyList(ByVal aResidenceID As Integer) As DataSet


    Dim cn As New SqlConnection(ConfigurationSettings.AppSettings("ConnectionString"))
    Dim cmd As New SqlCommand
    Dim ds As DataSet
    Dim strSQL As String

    strSQL = "SELECT CountyName FROM " + HousingDB() + "vwdirectorycounties WHERE ResourceUniqueID=" + aResidenceID.ToString + " ORDER BY CountyName"
    cmd.CommandText = strSQL
    cmd.CommandType = CommandType.Text
    cmd.Connection = cn

    'Dim param As SqlParameter

    'param = cmd.Parameters.Add("@ResidenceID", SqlDbType.Int)
    'param.Value = aintResidenceID

    Dim da As SqlDataAdapter = New SqlDataAdapter(cmd)

    ds = New DataSet

    da.Fill(ds)

    Return ds

  End Function

  Private Function GetSQLFromList(ByVal astrList As String, ByVal aExpression As String) As String

    'aExpression = could be "=1" or could be ">0"

    Dim Array() As String
    Dim List As String
    Dim strTempWhere As String = ""
    Dim i As Integer

    If astrList <> Nothing Then
      Array = Split(astrList, ",")

      For i = 0 To UBound(Array)
        strTempWhere += " OR (" + Array(i) + aExpression + ") "
      Next

      If Mid(strTempWhere, 1, 3) = " OR" Then
        strTempWhere = " AND " + "(" + Mid(strTempWhere, 4, strTempWhere.Length) + ") "
      End If

    End If

    Return strTempWhere

  End Function

  Private Function GetSQLForResidenceName(ByVal astrResidenceName As String) As String

    Dim strSQLWhere As String = ""

    If astrResidenceName.Length > 0 Then
      astrResidenceName = "'%" + Replace(astrResidenceName, "'", "''") + "%'"
      strSQLWhere += " AND ((ISNULL(ResidenceName,'') LIKE " + astrResidenceName + " OR ISNULL(ResAlternateName,'') LIKE " + astrResidenceName
      strSQLWhere += "	OR ISNULL(ResAddress,'') LIKE " + astrResidenceName + " OR ISNULL(ResAddress1,'') LIKE " + astrResidenceName + ")) "
    End If

    Return strSQLWhere

  End Function

  Private Function GetSQLForPrograms(ByVal astrProgramList As String) As String

    Dim Programs() As String
    Dim strTempWhere As String = ""
    Dim i As Integer

    If astrProgramList <> Nothing Then
      Programs = Split(astrProgramList, ",")
      For i = 0 To UBound(Programs)
        Select Case Programs(i)
          Case "SPECIAL-1"
            strTempWhere += " OR (Section8=1 OR PublicHousing=1 OR Section202=1 OR Section236=1 OR Section515=1 OR Section811=1 OR (OtherProjBased=1)) "
          Case "SPECIAL-2"
            strTempWhere += " OR (Section42=1 OR OtherTaxFinanced=1 ) "
          Case "SPECIAL-3"
            strTempWhere += " OR (Section8Voucher=1 OR Section42=1 OR Bridges=1 OR RAFS=1 OR PrivateMarket=1 OR OtherTenantBased=1 OR TenantBased=1) "
          Case "SPECIAL-4"
            strTempWhere += " OR (Transitional=1 OR Rule36=1 OR ELHIForHTF=1) "
            'strTempWhere += " OR (Transitional=1) "
          Case "SPECIAL-supporttemp"
            strTempWhere += " OR (Transitional=1 AND LengthOfStayTemporary=1) "
          Case "SPECIAL-supportperm"
            strTempWhere += " OR (Transitional=1 AND LengthOfStayPermanent=1) "
            'Case "SPECIAL-Katrina"
            '  strTempWhere += " OR (Katrina=1) "
            '  'SPECIAL-Katrina
          Case "SPECIAL-5"
            strTempWhere += " OR (Katrina=1) "
          Case Else
            strTempWhere += " OR (" + Programs(i) + "=1) "

        End Select
      Next
      If Mid(strTempWhere, 1, 3) = " OR" Then
        strTempWhere = " AND " + "(" + Mid(strTempWhere, 4, strTempWhere.Length) + ") "
      End If
    End If

    Return strTempWhere

  End Function

  '========================================================================================
  'Sub AddSearch - Add info about search criteria selected
  '========================================================================================
  Public Sub AddSearch(ByVal aCityList As String, ByVal aCountyList As String, _
  ByVal aBuildingTypes As String, ByVal aGroupsServed As String, _
  ByVal aHousingPrograms As String, ByVal aSupportiveServices As String, _
  ByVal aBedrooms As String, ByVal aAccessibilityNeeeds As Integer, _
  ByVal aPropertyName As String, ByVal aSessionID As String, ByVal aIPAddress As String)

    Dim cn As New SqlConnection(ConfigurationSettings.AppSettings("ConnectionString"))
    cn.Open()
    Dim cmd As New SqlCommand
    Dim ds As DataSet

    cmd.CommandText = "AddSearch"
    cmd.CommandType = CommandType.StoredProcedure
    cmd.Connection = cn

    Dim param As SqlParameter

    param = cmd.Parameters.Add("@Cities", SqlDbType.VarChar)
    param.Value = aCityList

    param = cmd.Parameters.Add("@Counties", SqlDbType.VarChar)
    param.Value = aCountyList

    param = cmd.Parameters.Add("@BuildingTypes", SqlDbType.VarChar)
    param.Value = aBuildingTypes

    param = cmd.Parameters.Add("@GroupsServed", SqlDbType.VarChar)
    param.Value = aGroupsServed

    param = cmd.Parameters.Add("@HousingPrograms", SqlDbType.VarChar)
    param.Value = aHousingPrograms

    param = cmd.Parameters.Add("@SupportiveServices", SqlDbType.VarChar)
    param.Value = aSupportiveServices

    param = cmd.Parameters.Add("@Bedrooms", SqlDbType.VarChar)
    param.Value = aBedrooms

    param = cmd.Parameters.Add("@AccessibilityNeeds", SqlDbType.SmallInt)
    param.Value = aAccessibilityNeeeds

    param = cmd.Parameters.Add("@PropertyName", SqlDbType.VarChar)
    param.Value = aPropertyName

    param = cmd.Parameters.Add("@SessionID", SqlDbType.VarChar)
    param.Value = aSessionID

    param = cmd.Parameters.Add("@IPAddress", SqlDbType.VarChar)
    param.Value = aIPAddress

    cmd.ExecuteNonQuery()

  End Sub

End Class
